<?php

namespace FiloBlu\Esb\Model\Rest;

use Exception;
use FiloBlu\Esb\Api\ObjectTypeServiceInterface;
use FiloBlu\Esb\Framework\Event\EventEmitter;
use FiloBlu\Esb\Model\EventResolver;
use Magento\Framework\Exception\NoSuchEntityException;

/**
 * Class ObjectTypeService
 * @package FiloBlu\Esb\Model\Rest
 */
class ObjectTypeService implements ObjectTypeServiceInterface
{
    /**
     * @var EventEmitter
     */
    private $eventEmitter;

    /**
     * @var EventResolver
     */
    private $eventResolver;

    /**
     * OrderSaveAfter constructor.
     * @param EventEmitter $eventEmitter
     * @param EventResolver $eventResolver
     */
    public function __construct(EventEmitter $eventEmitter, EventResolver $eventResolver)
    {
        $this->eventEmitter = $eventEmitter;
        $this->eventResolver = $eventResolver;
    }

    /**
     * @param string $event
     * @param mixed $message
     * @return mixed|void
     * @throws NoSuchEntityException
     * @throws Exception
     */
    public function push($event, $message)
    {
        $event = $this->eventResolver->get($event);
        $this->eventEmitter->emit($event, $message);
    }
}
